import { Type, TypeChecker as RawTypeChecker, Symbol } from "typescript";
export declare type TypeChecker = RawTypeChecker & {
    readonly isTypeAssignableTo?: (type1: Type, type2: Type) => boolean;
};
export declare const single: <A>(as: readonly A[]) => A | undefined;
/**
 * Throws away non-object types (string, number, boolean, etc) because we don't check those for readonly -> mutable assignment
 * and returns an array of pairs of types that are assignable.
 */
export declare const assignableObjectPairs: (rawDestinationType: Type, rawSourceType: Type, checker: TypeChecker) => ReadonlyArray<{
    readonly destinationType: Type;
    readonly sourceType: Type;
}>;
export declare const symbolToType: (s: Symbol, checker: TypeChecker) => Type | undefined;
